<script setup lang="ts">
import { useCheckInOutStore } from '@/stores/checkInOut'
import { computed, onMounted, reactive, ref, watch, watchEffect } from 'vue'
import { type CheckInOut } from '@/types/CheckInOut'
import LoginDialog from './LoginDialog.vue'
import LogOutDialog from './LogOutDialog.vue'
import checkInOutService from '@/services/checkInOut'
import { useDate } from 'vuetify'
import { useLoadingStore } from '@/stores/loading'
import { useMessageStore } from '@/stores/message'
import { useUserStore } from '@/stores/user'
import { useAuthStore } from '@/stores/auth'
import MapView from '@/views/Branch/MapView.vue'
import { useBranchStore } from '@/stores/branch';

const authStore = useAuthStore()
const checkInOutStore = useCheckInOutStore()
const loadingStore = useLoadingStore()
const messageStore = useMessageStore()
const userStore = useUserStore()
const mapDialog = ref(false)
const currentDate = ref()
const currentTime = ref()
const email = ref('')
const password = ref('')
const now = new Date()
const time = new Date().toLocaleTimeString()
const checkInOuts = computed(() => checkInOutStore.checkInOuts);


const selectedMonth = ref(new Date().getMonth() + 1)
const selectedYear = ref(new Date().getFullYear())

const months = ref([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12])
const years = ref([2022, 2023, 2024, 2025])




onMounted(() => {
  checkInOutStore.getCheckInOuts()
  checkInOutStore.fetchDataByMonthAndYear(selectedMonth.value, selectedYear.value)
  setupDateAndTime()
  //checkInOutStore.fetchDataByMonthAndYear(selectedMonth.value, selectedYear.value)
})

const onMonthYearChange = () => {
  checkInOutStore.fetchDataByMonthAndYear(selectedMonth.value, selectedYear.value)
}


watch([selectedMonth, selectedYear], () => {
  checkInOutStore.fetchDataByMonthAndYear(selectedMonth.value, selectedYear.value)
  console.log(checkInOuts.value)
})


const visible = ref(false)


const adapter = useDate()
const date: Date = new Date()
console.log(date)

const checkInoutStore = reactive({
  // ... โค้ดอื่น ๆ ที่มีอยู่
  selectedRows: [] as CheckInOut[] // เพิ่ม selectedRows เป็น array ของ CheckInOut

})

const setupDateAndTime = () => {
  currentDate.value = `${now.getDate()}/${now.getMonth() + 1}/${now.getFullYear()}`
  currentTime.value = `${time}:${now.getMinutes()}`

  setInterval(() => {
    const newNow = new Date()
    currentDate.value = `${newNow.getDate()}/${newNow.getMonth() + 1}/${newNow.getFullYear()}`
    currentTime.value = `${newNow.toLocaleTimeString()}`
  }, 1000)
}
function formatTime(time: any) {
  if (time) {
    return new Date(time).toLocaleTimeString('th-TH', { hour12: false })
  } else {
    return 'null'
  }
}
function formatDate(date: any) {
  return new Date(date).toLocaleDateString('th-TH')
}

const status = ref<string[]>([])
const salary = ref<number>(0)
const idToCal = ref(0)
// const onSubmit = async () => {
//   checkInOutStore.logIn(email.value, password.value)
// }
async function getsalary(id: number) {
  const data = await userStore.CalculateSalary(id)
  if (data) {
    console.log(data[0])
    salary.value = data[0].Salary
    console.log(salary.value)
  }
}



</script>

<template>
  <!--ยังไม่ได้แยก-->
  <div>
    <v-sheet>
      <v-container fluid>
        <v-toolbar flat fluid color="#AB9283">
          <v-toolbar-title>Check IN / Check OUT</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer>
            <div>วันที่:{{ currentDate }} เวลา {{ currentTime }}</div>
          </v-spacer>
          <v-spacer></v-spacer>

          <v-row>
            <!-- <v-combobox v-model="selectedMonth" :items="months" label="Month"></v-combobox>
            <v-combobox v-model="selectedYear" :items="years" label="Year"></v-combobox> -->

          </v-row>
          <!-- <v-btn @click="onMonthYearChange()">Apply</v-btn> -->
          <v-dialog v-model="checkInOutStore.filterDialog" persistent width="960">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" class="mr-2" prepend-icon="mdi-magnify"> ค้นหา </v-btn>
            </template>

            <v-card style="background-color: #fff5e8">
              <v-card-title style="text-align: center; font-size: 24px" class="mb-0 mt-3">
                <strong>ค้นหาเงินเดือน</strong>
              </v-card-title>

              <v-card-text>
                <v-form v-model="checkInOutStore.from">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="idToCal" :rules="[(v) => !!v || 'Field is required']" class="mb-2"
                          clearable label="id" variant="outlined" filled rounded>
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <div>{{ salary }}</div>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>

              <v-card-actions class="mt-0">
                <v-spacer></v-spacer>
                <v-btn variant="text" @Click="getsalary(idToCal)"> submit </v-btn>
                <v-btn variant="text" @click="checkInOutStore.filterDialog = false">Close</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="checkInOutStore.loginDialog" persistent width="600">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" class="mr-2" prepend-icon="mdi-login"> Login </v-btn>
            </template>

            <v-card style="background-color: #fff5e8">
              <v-card-title style="text-align: center; font-size: 24px" class="mb-0 mt-3">
                <strong>Check IN</strong>
                <div>วันที่:{{ currentDate }} เวลา {{ currentTime }}</div>
              </v-card-title>

              <v-card-text>
                <v-form v-model="checkInOutStore.from" @submit.prevent="checkInOutStore.onSubmit">
                  <v-container>
                    <v-row justify="center" align="center">
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field v-model="checkInOutStore.editedCheckinout.email"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="Email"
                          variant="outlined" filled rounded>
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field v-model="checkInOutStore.editedCheckinout.password"
                          :type="visible ? 'text' : 'password'" :readonly="checkInOutStore.loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="Password"
                          placeholder="Enter your password" variant="outlined" filled rounded>
                        </v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>

              </v-card-text>


              <v-card-actions class="mt-0">
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="checkInOutStore.save()"> Login </v-btn>
                <v-btn variant="text" @click="checkInOutStore.closeDialog()"> Close </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="checkInOutStore.logoutDialog" persistent width="600">
            <v-card style="background-color: #fff5e8">
              <v-card-title style="text-align: center; font-size: 24px" class="mb-0 mt-3">
                <strong>Check OUT</strong>
                <div>วันที่:{{ currentDate }} เวลา {{ currentTime }}</div>
              </v-card-title>

              <v-card-text>
                <v-form v-model="checkInOutStore.from" @submit.prevent="checkInOutStore.onSubmit">
                  <v-container>
                    <v-row justify="center" align="center">
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field v-model="checkInOutStore.editedCheckinout.email"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="Email"
                          variant="outlined" filled rounded>
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field v-model="checkInOutStore.editedCheckinout.password"
                          :type="visible ? 'text' : 'password'" :readonly="checkInOutStore.loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="Password"
                          placeholder="Enter your password" variant="outlined" filled rounded>
                        </v-text-field>
                      </v-col>

                      <!-- <v-col cols="12" sm="12" md="4">
                        <v-combobox v-model="checkInOutStore.editedCheckinout.status" :items="['Present', 'Absent']"
                          label="Status">
                        </v-combobox>
                      </v-col> -->
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>

              <v-card-actions class="mt-0">
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="checkInOutStore.save()"> Logout </v-btn>
                <v-btn variant="text" @click="checkInOutStore.closeDialog()"> Close </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="checkInOutStore.dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="checkInOutStore.closeDelete">Cancel</v-btn>
                <v-btn variant="text" @click="checkInOutStore.deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>


        </v-toolbar>


        <v-table fixed-header height="530">
          <thead>
            <tr>
              <th>Id</th>
              <th>ชื่อ-สกุล</th>
              <th>วันที่</th>
              <th>เวลาเข้า</th>
              <th>เวลาออก</th>
              <th>สถานะ</th>
              <th>ชั่วโมงรวม</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in checkInOuts" :key="item.id">
              <td>{{ item.id }}</td>
              <td>{{ item.user?.name }}</td>
              <td>{{ formatDate(item.date) }}</td>
              <td>{{ formatTime(item.timeIn) }}</td>
              <td>{{ formatTime(item.timeOut) }}</td>
              <td>{{ item.status }}</td>
              <td>{{ item.totalHour }}</td>
              <td>
                <v-icon v-if="item.status === 'Present'" @click="checkInOutStore.editItem(item)">mdi-logout</v-icon>
              </td>
            </tr>
          </tbody>

          <template v-if="!checkInOutStore.checkInOuts.length">
            <v-btn @click="checkInOutStore.getCheckInOuts()"> Reset </v-btn>
          </template>
        </v-table>
      </v-container>
      <v-dialog v-model="checkInOutStore.mapDialog" max-width="400" height="700">
        <v-card class="px-2">
          <v-card-title class="text-h5 d-flex justify-center">กำลังตั้งค่าพิกัด</v-card-title>
          <v-row class="d-flex justify-center align-center">
            <map-view></map-view>
          </v-row>
        </v-card>
      </v-dialog>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
